<!DOCTYPE html>
<html data-bs-theme="dark">

<head>
    <title>Dice Roll Simulator</title>
    <!-- Add Bootstrap CSS from a CDN -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/css/bootstrap.min.css">

    <script src="https://cdn.plot.ly/plotly-latest.min.js"></script>
</head>

<body>
    <div class="container">
        <h1 class="mt-5">Dice Roll Simulator</h1>
        <p>Enter a roll string as below. You can use operators like `<=` or `>` to evaluate logical true or false. </p>    
        <p>Beware: when evaluated these expressions turn into `1` and `0` for true and false respectively</p>
        <p>Limitations:
            <list>
                <li>Division is not supported</li>
                <li>Leading negatives are not supported. Try 0-1d4 or the like if you need a negative value</li>
            </list>
        </p>
        <form id="rollSimForm" class="mt-3">
            <div class="mb-3">
                <label for="rollstring" class="form-label">Roll String:</label>
                <input type="text" id="rollstring" class="form-control" name="rollstringInput"
                    placeholder="2d20kh1 + 3 + 3" required><br><br>
            </div>
            <div class="mb-3">
                <label for="iterations" class="form-label">Iteration Number:</label>
                <input type="number" id="iterations" class="form-control" name="iterationsInput" placeholder="2500"
                    required><br><br>
            </div>

            <input type="submit" class="btn btn-primary" value="Submit">
        </form>

    </div>

    <!-- Create a Bootstrap container for statistics -->
    <div id="statistics" class="container mt-5">
        <h2>Statistics</h2>
        <p><strong>Mean:</strong> <span id="meanValue">N/A</span></p>
        <p><strong>Median:</strong> <span id="medianValue">N/A</span></p>
        <p><strong>Mode:</strong> <span id="modeValue">N/A</span></p>
        <p><strong>IQR:</strong> <span id="iqrValue">N/A</span></p>
        <p><strong>Range:</strong> <span id="rangeText">[ N/A, N/A ] (N/A)</span></p>
    </div>

    <div class="container">
        <label for="histogramtype">Display type</label>
        <select name="histogramtype" class="form-select" id="histogramtype" value="raw">
            <option value="raw">Raw rolls</option>
            <option value="pdf">Probability distribution</option>
            <option value="cdf">Cumulative distribution</option>
            <option value="sf">1 - Cumulative distribution</option>
        </select>
    </div>
    <div id="histogram" class="mt-5"></div>

    <!-- Footer -->
    <footer class="bg-light text-center ">

        <!-- Copyright -->
        <div class="text-center p-3" style="background-color: rgba(0, 0, 0, 0.8)">
            Rust Diceroller || Version: <span id="ver"></span> || Repo: <a class="text-light"
                href="https://gitlab.com/asimm.hirani/rust-diceroller">Rust Diceroller @ Gitlab.com</a>
            <br />
            &copy; 2023 Copyright:
            <a class="text-light" href="https://asimmhirani.me/">Asimm Hirani</a>
        </div>
        <!-- Copyright -->

    </footer>
    <!-- Footer -->

    <script>
        function updateView() {
            const type = document.getElementById("histogramtype").value;
            const isNormalised = type != "raw";
            const isCumulative = type == "cdf" || type == "sf";

            // Create a new histogram trace
            const trace = {
                x: histogramData,
                type: "histogram",
                histnorm: isNormalised ? "probability" : "",
                cumulative: {
                    enabled: isCumulative,
                    direction: type == "sf" ? "decreasing" : "increasing",
                },
            };

            // Define layout options for the histogram
            const layout = {
                title: type == "pdf" ? "Empirical Probability Distribution Function" : type == "cdf" ? "Empirical Cumulative Distribution Function" : type == "sf" ? "Empirical Survival Function (chance to pass a DC x check)" : "Histogram of Empirical Results",
                xaxis: { title: type == "sf" ? "DC" : "Value" },
                yaxis: {
                    title: isNormalised ? "Probability" : "Frequency",
                    // // Set the aspect ratio to enforce 2:3
                    // scaleanchor: 'x',
                    // scaleratio: 2 / 3,
                },
            };

            // Plot the histogram in the 'histogram' div
            Plotly.newPlot('histogram', [trace], layout);

            // Display statistics
            const { mean, mode, quartiles: [min, q1, median, q3, max] } = histogramStatistics;
            const iqr = q3 - q1;

            document.getElementById("meanValue").textContent = mean.toFixed(2);
            document.getElementById("medianValue").textContent = median.toFixed(2);
            document.getElementById("modeValue").textContent = mode.toFixed(2);
            document.getElementById("iqrValue").textContent = iqr.toFixed(2);
            document.getElementById("rangeText").textContent = "[ " + min.toFixed(2) + ", " + max.toFixed(2) + " ] (" + (max - min).toFixed(2) + ")";

        }

        // Helper function to calculate the mean
        function calculateMean(data) {
            const sum = data.reduce((acc, value) => acc + value, 0);
            return sum / data.length;
        }

        // Helper function to calculate the mode
        function calculateMode(data) {
            const counts = {};
            data.forEach(value => {
                counts[value] = (counts[value] || 0) + 1;
            });

            let mode;
            let maxCount = 0;
            for (const value in counts) {
                if (counts[value] > maxCount) {
                    mode = parseFloat(value);
                    maxCount = counts[value];
                }
            }
            return mode;
        }

        // Helper function to calculate quartiles for the IQR and median
        function calculateQuartiles(data) {
            const sortedData = data.slice().sort((a, b) => a - b);
            const N = sortedData.length;
            // Returns the nth quartile
            const Q = n => {
                const i = (N - 1) / 4 * n;
                const partial = i % 1;
                const lower = sortedData[i - partial];
                if (partial === 0) return lower;
                const upper = sortedData[i - partial + 1];
                return lower * (1 - partial) + upper * partial;
            }

            return [Q(0), Q(1), Q(2), Q(3), Q(4)];
        }

        function calculateStatistics(data) {
            return { mean: calculateMean(data), mode: calculateMode(data), quartiles: calculateQuartiles(data) }
        }

        document.getElementById("rollSimForm").addEventListener("submit", function (event) {
            event.preventDefault();

            // Get the form values
            const rollStringValue = document.getElementById("rollstring").value;
            const iterationsValue = parseInt(document.getElementById("iterations").value);

            // Create a JavaScript object with the form data
            const formData = {
                iterations: iterationsValue,
                rollstring: rollStringValue
            };

            const newHash = "#rollstring=" + encodeURIComponent(rollStringValue) + "&iterations=" + iterationsValue + "&t=" + document.getElementById("histogramtype").value;
            if (location.hash !== newHash) {
                history.replaceState(undefined, undefined, newHash);
            }

            // Convert the form data to JSON
            const jsonData = JSON.stringify(formData);

            console.log("Request: ", jsonData)

            // Make a POST request to your endpoint
            fetch("rollapi/v1/roll", {
                method: "POST",
                headers: {
                    "Content-Type": "application/json"
                },
                body: jsonData
            })
                .then(response => response.json()) // Parse the response as JSON
                .then(data => {
                    // Extract the 'result' array from the response
                    const resultArray = data.result;

                    // Update the histogramData with the new results
                    histogramData = resultArray;
                    histogramStatistics = calculateStatistics(histogramData);

                    // Update the histogram
                    updateView();
                })
                .catch(error => {
                    console.error("Error:", error);
                });

            // Reset the form
            // document.getElementById("rollSimForm").reset();
        });

        if (location.hash) {
            const search = new URLSearchParams(location.hash.slice(1));  // (Remove leading #)
            const rollStringValue = search.get("rollstring");
            if (rollStringValue) document.getElementById("rollstring").value = rollStringValue;
            const iterationsValue = +search.get("iterations");
            if (iterationsValue) document.getElementById("iterations").value = iterationsValue;
            const type = search.get("t");
            if (type) document.getElementById("histogramtype").value = type;
        }

        document.getElementById("histogramtype").addEventListener("change", () => {
            if (typeof histogramData !== 'undefined') {
                updateView();

                const search = new URLSearchParams(location.hash.slice(1));
                const newType = document.getElementById("histogramtype").value;
                if (search.get("t") != newType) {
                    search.set("t", newType);
                    history.replaceState(undefined, undefined, "#" + search);
                }
            }
        })


        const verSpan = document.getElementById("ver");
        fetch("rollapi/v1/version")
            .then(response => {
                // Check if the response status is OK (200)
                if (response.ok) {
                    // Parse the response JSON or text, depending on your server's response
                    return response.text(); // Use response.json() if the server returns JSON
                } else {
                    throw new Error("Failed to fetch version");
                }
            })
            .then(version => {
                // Update the text of the span element with the fetched version
                verSpan.textContent = version;
            })
            .catch(error => {
                console.error(error);
                verSpan.textContent = "Failed to fetch version";
            });

    </script>

    <!-- Add Bootstrap JavaScript from a CDN -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js"></script>

</body>

</html>
